///////////////////////////////////////////////////////////////////////
//
// File: test.cpp
// Author: Kelvin Sung
// Date: April 2003
//
//
//
//   Termination in Sequence? Or not?
//
//
#include <iostream.h>

#include "TthreadBase.h"

#include <Windows.h>


int main() {

	TsyncObject &sync = TthreadBase::GetSyncObject();

	//
	// Start all the worker threads ...
	//
	for (int i=0; i<kLastThread; i++) {
		TthreadBase *td = new TthreadBase(kLastThread-1-i);
		td->StartThread();
	}

	
	int command;
	cout << "Command [0 1 2 3]? ";
	cin >> command;
	
	int seq = command+1;
	while (seq != command) {
		sync.SetCommand(seq);
		sync.CommandIsRead();
		Sleep(1);
		if (seq == kLastThread-1)
			seq = 0;
		else seq += 1;
	}
	
	sync.SetCommand(seq);
	while (!sync.Identified(command));

	cerr << "Main terminates!" << endl;

	return 0;
}
