//////////////////////////////////////////////////
// File: TthreadBase.cpp
// Author: Kelvin Sung
// Date: April 2003
// 
//
//
#include "TthreadBase.h"

#include <windows.h>
			// for Sleep

#include <iostream.h>
#include <iomanip.h>
			// for cout/cin/cerr, and i/o formatting

#include <fstream.h>
			// for ostream

#include <process.h>
			// for _beginthread and _endthread

#include <stdio.h>
			// for sprintf


// #inlcude <afxmt.h>
//			// for MFC synchronization objects: CMutex/CEvent
//	

//
// To Compile: for Both Debug and Release:
//    Must include compiler optins: /MT /D "_X86_"
//
// To Link: 
//          For Debug Must include:   LIBCMTD.lib and MSVCRTD.lib
//			For Release Must include: LibCMT.LIB and MSVCRT.LIB
//
//    NAFXCWD.lib (NAFXCW.LIB for Release) must appear _BEFORE_ LIBCMTD.LIB)
//
//
//
static void StupicThreadWorker(void *parm)
{
	TthreadBase *td = (TthreadBase *) parm;
	TsyncObject &syncObj = td->GetSyncObject();
	
	while ( !syncObj.Identified(td->ThreadID()) );
	cerr << "Thread: id[" << td->ThreadID() << "]: Done!" << endl;

	_endthread();

}

///////////////////////////////////////////////////////////////////////////////////////
//
// ThreadBase methods
//
/////////////////////////////////////////////////////////////////////////////////////

		TsyncObject TthreadBase::sfSyncObj;
			// definition of class object

void
TthreadBase::StartThread()
{
	_beginthread(StupicThreadWorker, 0, (void *) this );
}

