////////////////////////////////////////////////////////////////
//
// file: TthreadBase.h
// Author: Kelvin Sung
// Date: April 2003
//
//
//
#ifndef TTHREAD_BASE_H
#define TTHREAD_BASE_H

#include "TsyncObject.h"

#define kLastThread 5

class TthreadBase {
	private:
		static		TsyncObject sfSyncObj;		

	protected:
		int			fID;					// id of this thread
	public:
		static TsyncObject& GetSyncObject() { return sfSyncObj; }

		TthreadBase(int id) : fID(id)	
				{}

		const int ThreadID() const { return fID; }
		void StartThread();
};
#endif


					
